import java.util.LinkedList;


public class WeaponManager implements Runnable {

	private LinkedList weapons = new LinkedList();
	WillPangGraphics wpGraphics;
	WillPangImagePane imagePane;
	
	int nextHarpNum = 0;

	boolean [] activeHarpoons;// = new boolean [imagePane.willPang.absouteMaxHarpoons];
	
	boolean continueLoop = true;
	
	public WeaponManager (WillPangImagePane imagePane) {
		this.imagePane = imagePane;

		wpGraphics = imagePane.wpGraphics;

		activeHarpoons = new boolean [imagePane.willPang.absouteMaxHarpoons];
		
	 	// Initialize the bullet (for some reason)
		// so that when the first bullet is fired, it fires
		imagePane.willPang.playAudio = false;
		new Bullet(imagePane,0 ,wpGraphics,0, 0);
		imagePane.numHarpoons[0] = 0;
		imagePane.willPang.playAudio = true;	
		

	}
	
	public void addWeapon (int x, int y, int weaponNum) {
		try{
			// Update the wpGraphics and background
			wpGraphics.graphics = imagePane.graphics;
			wpGraphics.background = imagePane.background;
			
			int freePosition = -1;
			for (int i = 0; i<activeHarpoons.length; i++) {
				if (!activeHarpoons[i] && freePosition == -1)
					freePosition = i;
			}

			if (weaponNum == 0) {		
				weapons.add(new Harpoon(imagePane, freePosition+2, wpGraphics, x, y, false));
			}
			if (weaponNum == 1) {
				weapons.add(new Harpoon(imagePane, freePosition+2, wpGraphics, x, y, true));
			
			}
			if (weaponNum == 2) {
				weapons.add(new Bullet(imagePane, freePosition+2, wpGraphics, x, y + 10));
			
			}

		//	System.out.println(freePosition);
			activeHarpoons[freePosition] = true;
		} catch (ArrayIndexOutOfBoundsException e) {
		}	

	}
	
	public void setContinueLoop (boolean newLoop) {
		continueLoop = newLoop;
	}

	
	public void resetWeapons () {
		weapons = new LinkedList();
		activeHarpoons = new boolean [imagePane.willPang.absouteMaxHarpoons];
		
	}

	public void run() {
		
		
		while (continueLoop) {

//			System.out.println(weapons.size());
			
			if (!imagePane.gameState[3]) {
				updateAll();
			} else {
				removeAll();
			}			
			// Doze the inputted time
			Delegate.doze(imagePane.willPang.harpoonFrameRate);
		}
		
	
	}
	
	private void removeAll () {
		
		Weapon currentWeapon;
		
		for (int i = 0; i < weapons.size(); i++) {

			currentWeapon = (Weapon) weapons.get(i);
			currentWeapon.remove();
			removeWeapon(i);
		
		}
	}
	
	private void removeWeapon (int toRemove) {
	
		LinkedList newList = new LinkedList ();
		
		for (int i = 0; i < weapons.size(); i++) {
		
			if (i != toRemove) {
				newList.add(weapons.get(i));
			} else {
				activeHarpoons[((Weapon) weapons.get(i)).harpNo - 2] = false;
			}
		
		}
		
		weapons = newList;
		
	}
	
	/** Interate thorough all of the weapons
	 */
	public void updateAll () {
	
		Weapon currentWeapon;
		
		for (int i = 0; i < weapons.size(); i++) {

			// Get the next weapon in the list
			currentWeapon = (Weapon) weapons.get(i);
	
			// Move the weapon
			currentWeapon.move();
			
			// Draw the weapon
			currentWeapon.draw();
			
			// Kill the weapon (if dead)
			if (currentWeapon.isDead()) {
				currentWeapon.remove();
				removeWeapon(i);
			}
				
				
			
		}
	}
}

//class 